<?php 

/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : objects.php
**      SYSTEM NAME    : Gnucomo - Gnu Computer Monitoring
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      : Objects Administration page.
**                     Input parameters: action (POST) : empty, 'Create'
**                                      objname (POST) : name of the object to create or remove
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Dec 04, 2002
**      LAST UPDATE     : Feb 03, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: objects.php,v $
   Revision 1.2  2003/02/05 09:48:14  arjen
   Added display and handling of notifications

******************************/

// RCSID = "$Id: objects.php,v 1.2 2003/02/05 09:48:14 arjen Exp $";

session_start();
require_once('classes/gnucomo_config.php');
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel='stylesheet' href='gnucomo.css' type='text/css'>
<title>GNUCoMo login</title>

<script language='JavaScript'>
function CheckCreate(f)
{
   if (f.objectname.value == "")
   {
      alert("You must supply a name");
      return false;
   }
   return true;
}

function CheckRemove(f)
{
   var message = "Are you sure you want to remove object ";
   message += f.objectname.value;
   message += " ?";

   return confirm(message);
}

</script>

</head>
<body>
<?php
if (empty($_SESSION['username']))
{
   echo "Please log in first.";
}
else
{
   echo "<h1>Objects Administration</h1><hr>";

   $config = new gnucomo_config;

   $config->read("gnucomo");

   //  Connect to the database
   $conn = pg_connect($config->Database($_SESSION['username'], $_SESSION['password']));


   if (isset($_POST['action']) && $_POST['action'] == 'Create' && !empty($_POST['objectname']))
   {
      pg_exec($conn, "INSERT INTO object (objectname) VALUES ('"
                     . $_POST['objectname'] . "')");
   }

   if (isset($_POST['action']) && $_POST['action'] == 'Remove' && !empty($_POST['objectname']))
   {
      pg_exec($conn, "DELETE FROM object WHERE objectname='" . $_POST['objectname'] . "'");
   }

   $res = pg_exec($conn, "SELECT objectid,objectname FROM object");

   echo "<table>";
   $obj = 0;
   while ($obj < pg_numrows($res))
   {
      $u = pg_fetch_object($res, $obj);
      $r = pg_exec($conn, "SELECT count(logid) FROM log WHERE objectid='"
                           . $u->objectid . "'");
      $r = pg_fetch_object($r, 0);

      $nr_logs = $r->count;

      $r = pg_exec ($conn, "SELECT count(paramid) FROM parameter WHERE objectid='"
                           . $u->objectid . "'");
      $r = pg_fetch_object($r, 0);

      $nr_params = $r->count;

      $r = pg_exec ($conn, "SELECT count(notificationid) FROM notification WHERE objectid='"
                           . $u->objectid . "'");
      $r = pg_fetch_object($r, 0);

      $nr_notifications = $r->count;
      ?>
      <tr><td align='center'><img src='server.png'><br>
             <b><?php echo $u->objectname ?></b>
      </td><td>
          <?php echo $nr_logs?> <a href='log.php?oid=<?php echo $u->objectid?>'>Log entries</a>
      </td><td>
          <?php echo $nr_params?> <a href='parameter.php?oid=<?php echo $u->objectid?>'>Parameters</a>
      </td><td>
          <?php echo $nr_notifications?> <a href='notification.php?oid=<?php echo $u->objectid?>'>Notifications</a>
      </td><td>
          <form action='objects.php' method='post' onSubmit='return CheckRemove(this)'>
              <input type='hidden' name='objectname' value='<?php echo $u->objectname ?>'>
              <input type='submit' name='action' value='Remove'>
          </form>
      </td></tr>
      <?php
      $obj++;
   }
   echo "</table>";

}
?>

<h2>Create new object:</h2>
<p>

<form action='objects.php' method='post' onSubmit='return CheckCreate(this)'>
Objects name (FQDN): <input name='objectname' type='text'>
<br>
<input type='submit' name='action' value='Create'>
</form>
</p>
</body>
</html>
