<?php 

/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : parameter_compare.php
**      SYSTEM NAME    : Gnucomo - Gnu Computer Monitoring
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      : 
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Dec 04, 2002
**      LAST UPDATE     : Feb 03, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: parameter_compare.php,v $
   Revision 1.2  2003/02/05 09:47:39  arjen
   Display the difference of all package class parameters for two objects

******************************/

// RCSID = "$Id: parameter_compare.php,v 1.2 2003/02/05 09:47:39 arjen Exp $";

session_start();
require_once('classes/gnucomo_config.php');
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel='stylesheet' href='gnucomo.css' type='text/css'>
<title>Parameter comparison</title>


</head>
<body>
<?php

/*  Returns an associative array with all properties of a parameter (pid) */

function param_properties($db, $pid)
{
   $properties = NULL;
   $r = pg_exec($db, "SELECT name, value FROM property WHERE paramid='" . $pid . "'");
   for ($p = 0; $p < pg_numrows($r); $p++)
   {
      $prop = pg_fetch_object($r, $p);
      $properties[$prop->name] = $prop->value;
   }
   return $properties;
}

/*  Return true if both associative arrays are identical */

function property_compare($prop, $comp)
{
   $equal = true;

   if (empty($prop) || empty($comp))
   {
      $equal = empty($prop) && empty($comp);
   }
   else
   {
      reset($comp);
      foreach ($prop as $name => $val)
      {
         if ($equal)
         {
            $to_compare = each($comp);
            $equal = $to_compare[0] == $name && $to_compare[1] == $val;
         }
      }
   }
   return $equal;
}

/*   Display a parameter in two adjecent table cells  */

function display_parameter($name, $properties, $css_class = "")
{
   echo "<td";
   if ($css_class != "")
   {
      echo " class='$css_class'";
   }
   echo ">";
   echo $name;
   echo "</td><td";
   if ($css_class != "")
   {
      echo " class='$css_class'";
   }
   echo ">";
   foreach ($properties as $p_name => $p_value)
   {
      echo " $p_name=$p_value";
   }
   echo "</td>";
}

if (empty($_SESSION['username']))
{
   echo "Please log in first.";
}
else
{

   $config = new gnucomo_config;

   $config->read("gnucomo");

   //  Connect to the database
   $conn = pg_connect($config->Database($_SESSION['username'], $_SESSION['password']));

   if (!empty($_POST['oid']))
   {
      $res = pg_exec("SELECT objectid, objectname FROM object WHERE objectid=" . $_POST['oid']);
      $obj = pg_fetch_object($res, 0);
      echo "<h1>" . $_POST['class'] . " parameters for " . $obj->objectname;
      $res = pg_exec("SELECT objectid, objectname FROM object WHERE objectid=" . $_POST['compare_to']);
      $cmp_obj = pg_fetch_object($res, 0);
      echo " compared to " . $cmp_obj->objectname . "</h1><hr>";

      $res = pg_exec("SELECT objectid, paramid, name FROM parameter "
                     . "WHERE objectid=" . $obj->objectid . " OR objectid=" . $cmp_obj->objectid
                     . " AND class='" . $_POST['class'] . "' ORDER BY name, objectid");
      
     ?>
     <?php
      echo "<table>\n";
      echo "<tr><th colspan='2'>" . $obj->objectname . "</th>";
      echo "<th colspan='2'>" . $cmp_obj->objectname . "</th></tr>\n";
      echo "<tr><th>Name</th><th>Properties</th><th>Name</th><th>Propterties</th></tr>\n";
      $row = 0;
      while ($row < pg_numrows($res))
      {
         $par = pg_fetch_object($res, $row);
         $nextpar = 'false';
         if ($row + 1 < pg_numrows($res))
         {
            $nextpar = pg_fetch_object($res, $row + 1);
         }
         echo "<tr>";

         if ($nextpar && $par->name == $nextpar->name)
         {
            /*  Both objects have this parameter */
            $row++;

            $pr = param_properties($conn, $par->paramid);
            $prnext = param_properties($conn, $nextpar->paramid);
            if (property_compare($pr, $prnext))
            {
               display_parameter($par->name, $pr);
               display_parameter($nextpar->name, $prnext);
            }
            else
            {
               // We want the parameters of $obj on the left, so we need
               // to swap the left and right sides if appropriate.

               if ($par->objectid == $obj->objectid)
               {
                  display_parameter($par->name, $pr, "both");
                  display_parameter($nextpar->name, $prnext, "both");
               }
               else
               {
                  display_parameter($nextpar->name, $prnext, "both");
                  display_parameter($par->name, $pr, "both");
               }
            }
         }
         else
         {
            /*  Only one of the objects has this parameter */

            $pr = param_properties($conn, $par->paramid);

            if ($par->objectid == $obj->objectid)
            {
               /*  Parameter belongs to the object on the left */

               display_parameter($par->name, $pr, "left");
               echo "<td>&nbsp;</td><td>&nbsp;";
            }
            else
            {
               /*  Parameter belongs to the object on the right */

               echo "<td>";
               echo "&nbsp;</td><td>&nbsp;</td>";
               display_parameter($par->name, $pr, "right");
            }
         }
         echo "</tr>\n";
         $row++;
      }
      echo "</table>\n";
   }
}
?>

</body>
</html>
